ascend = require('ramda/src/ascend'); contains = require('ramda/src/contains'); gt = require('ramda/src/gt'); gte = require('ramda/src/gte'); lt = require('ramda/src/lt'); lte = require('ramda/src/lte'); map = require('ramda/src/map'); match = require('ramda/src/match'); pick = require('ramda/src/pick'); prop = require('ramda/src/prop'); replace = require('ramda/src/replace'); sortBy = require('ramda/src/sortBy'); sortWith = require('ramda/src/sortWith'); test = require('ramda/src/test'); where = require('ramda/src/where'); #auto_require: srcramda
{changeM, $} = RE = require 'ramda-extras' #auto_require: ramda-extras
[] = [] #auto_sugar
qq = (f) -> console.log match(/return (.*);/, f.toString())[1], f()
qqq = (...args) -> console.log ...args

utils = require './utils'
query = require './query'

PSE = utils.customError 'PopsiqlSQLError'

module.exports = (model, data) ->

	read: (fatQuery, hook = (entity, id, r) -> r) ->
		{entity, where, allFields, sortBy} = fatQuery
		whereTest = buildWhereTest where

		res = []
		for id,o of data[entity]
			if whereTest o
				r = pick allFields, o
				res.push hook entity, id, r

		if !sortBy then return res

		return $ res, sortWith buildSorter sortBy

	write: (delta) ->
		changeM delta, data

count = 0


buildWhereTest = (where) ->
	{AND, OR} = where
	if AND then return (o) -> buildWhereTest(AND[0])(o) && buildWhereTest(AND[1])(o)
	else if OR then return (o) -> buildWhereTest(OR[0])(o) || buildWhereTest(OR[1])(o)

	(o) ->
		for k,preds of where
			for op, v of preds
				# qq -> count++
				switch op
					when 'eq' then if o[k] != v then return false
					when 'neq' then if o[k] == v then return false
					when 'gt' then if o[k] <= v then return false
					when 'gte' then if o[k] < v then return false
					when 'lt' then if o[k] >= v then return false
					when 'lte' then if o[k] > v then return false
					when 'in' then if !contains o[k], v then return false
					when 'like' then if !test new RegExp(replace(/%/g, '.*', v)), o[k] then return false
					when 'ilike' then if !test new RegExp(replace(/%/g, '.*', v), 'i'), o[k] then return false
					when 'notlike' then if test new RegExp(replace(/%/g, '.*', v)), o[k] then return false
					when 'notilike' then if test new RegExp(replace(/%/g, '.*', v), 'i'), o[k] then return false

		return true

buildSorter = (sortBy) ->
	return $ sortBy, map (p) -> ascend prop(p)















